// General purpose register constants
export const R0 = 0x00;
export const AT = 0x01;
export const V0 = 0x02;
export const V1 = 0x03;
export const A0 = 0x04;
export const A1 = 0x05;
export const A2 = 0x06;
export const A3 = 0x07;
export const T0 = 0x08;
export const T1 = 0x09;
export const T2 = 0x0a;
export const T3 = 0x0b;
export const T4 = 0x0c;
export const T5 = 0x0d;
export const T6 = 0x0e;
export const T7 = 0x0f;
export const S0 = 0x10;
export const S1 = 0x11;
export const S2 = 0x12;
export const S3 = 0x13;
export const S4 = 0x14;
export const S5 = 0x15;
export const S6 = 0x16;
export const S7 = 0x17;
export const T8 = 0x18;
export const T9 = 0x19;
export const K0 = 0x1a;
export const K1 = 0x1b;
export const GP = 0x1c;
export const SP = 0x1d;
export const S8 = 0x1e;
export const RA = 0x1f;

// Control register constants
export const controlIndex = 0;
export const controlRand = 1;
export const controlEntryLo0 = 2;
export const controlEntryLo1 = 3;
export const controlContext = 4;
export const controlPageMask = 5;
export const controlWired = 6;
export const controlInvalid7 = 7;
export const controlBadVAddr = 8;
export const controlCount = 9;
export const controlEntryHi = 10;
export const controlCompare = 11;
export const controlStatus = 12;
export const controlCause = 13;
export const controlEPC = 14;
export const controlPRId = 15;
export const controlConfig = 16;
export const controlLLAddr = 17;
export const controlWatchLo = 18;
export const controlWatchHi = 19;
export const controlXContext = 20;
export const controlInvalid21 = 21;
export const controlInvalid22 = 22;
export const controlInvalid23 = 23;
export const controlInvalid24 = 24;
export const controlInvalid25 = 25;
export const controlParityError = 26;
export const controlCacheErr = 27;
export const controlTagLo = 28;
export const controlTagHi = 29;
export const controlErrorEPC = 30;
export const controlInvalid31 = 31;

export const causeExcShift = 2;

export const causeExcCodeInt = 0;  // Interrupt
export const causeExcCodeMod = 1;  // TLB Modification
export const causeExcCodeTLBL = 2;  // TLB Miss (load or instruction fetch)
export const causeExcCodeTLBS = 3;  // TLB Miss (store)
export const causeExcCodeAdEL = 4;  // Address Error (load or instruction fetch)
export const causeExcCodeAdES = 5;  // Address Error (store)
export const causeExcCodeIBE = 6;  // Bus Error (instruction fetch)
export const causeExcCodeDBE = 7;  // Bus Error (data reference: load or store)
export const causeExcCodeSys = 8;  // Syscall
export const causeExcCodeBp = 9;  // Breakpoint
export const causeExcCodeRI = 10;  // Reserved Instruction
export const causeExcCodeCpU = 11;  // Coprocessor Unusable
export const causeExcCodeOv = 12;  // Arithmetic Overflow
export const causeExcCodeTr = 13;  // Trap
export const causeExcCodeVCEI = 14;  // ?
export const causeExcCodeFPE = 15;  // Floating-Point
export const causeExcCodeWATCH = 23;  // Watch
export const causeExcCodeVCED = 31; // ?

